/*
** This file has been automatically generated by 'acconfig' from aclocal.m4
** Copyright (C) 1988 Eleftherios Gkioulekas <lf@amath.washington.edu>
**  
** This file is free software; as a special exception the author gives
** unlimited permission to copy and/or distribute it, with or without 
** modifications, as long as this notice is preserved.
** 
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
** implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

/* This is the top section */

@TOP@
/* This is the template section */

/* These are standard for all packages using Automake */
#undef PACKAGE
#undef VERSION

/* And now the rest of the boys */
#undef CXX_HAS_BUGGY_FOR_LOOPS
#undef CXX_HAS_NO_BOOL
#undef NDEBUG
#undef YOUR_OS

@BOTTOM@
/* This is the bottom section */

// This file defines portability work-arounds for various proprietory
// C++ compilers

// Workaround for compilers with buggy for-loop scoping
// That's quite a few compilers actually including recent versions of
// Dec Alpha cxx, HP-UX CC and SGI CC.
// The trivial "if" statement provides the correct scoping to the 
// for loop

#ifdef CXX_HAS_BUGGY_FOR_LOOPS
#undef for
#define for if(1) for
#endif

//
// Fortran-like integer looping macros
// these critters depend on the scoping work-around above
//

#define loop(COUNTER,BEGIN,END)  \
for (int COUNTER = BEGIN ; COUNTER <= END ; COUNTER ## ++)

#define inverse_loop(COUNTER,END,BEGIN) \
for (int COUNTER = END; COUNTER >= BEGIN; COUNTER ## --)

#define integer_loop(COUNTER,BEGIN,END,STEP) \
for (int COUNTER = BEGIN; COUNTER <= END; COUNTER += STEP)

//
// Class protection levels
// addictive syntactic sugar to make coding nicer
//

#define pub public:
#define pro protected:
#define pri private:

//
// Every mathematician would like to know pi
// so this is as good a place as any to throw it in.
//

#define pi 3.14159265358979324

//
// If the C++ compiler we use doesn't have bool, then
// the following is a near-perfect work-around. 
// You must make sure your code does not depend on "int" and "bool"
// being two different types, in overloading for instance.
//

#ifdef CXX_HAS_NO_BOOL
#define bool int
#define true 1
#define false 0
#endif
   
#include <assert.h>


